<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99g                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//check if the script is not included... if so: stop the execution
if(!defined('_phpipblocker_dir_'))
	die('Nothing to see here');

//require config.php + functions.php
if(!@require_once(_phpipblocker_dir_.'functions.php'))
	die('Unable to include <b>funtions.php</b>... cannot proceed... check the <b>\'_phpipblocker_dir_\'</b> is correctly setted');
if(!@require_once(_phpipblocker_dir_.'config.php'))
	die('Unable to include <b>config.php</b>... cannot proceed... check the <b>\'_phpipblocker_dir_\'</b> is correctly setted');

//security addon
unset($ipblocker_ban);

//find ip & hostname
$ipblocker_ban['ip'] = $_SERVER['REMOTE_ADDR'];
$ipblocker_ban['ip_coded'] = sprintf('%u', ip2long($ipblocker_ban['ip']));
$ipblocker_ban['hostname'] = gethostbyaddr($ipblocker_ban['ip']);

//proxy vars inizialization
$ipblocker_ban['using_proxy'] = false;
$ipblocker_ban['forwaded_for_ip'] = '';
$ipblocker_ban['forwaded_for_hostname'] = '';

//start transparent proxy check
if($ipblocker_config['proxyCheck'] && isset($_SERVER['HTTP_X_FORWARDED_FOR'])){
	$ipblocker_ban['forwaded_for_ip'] = $_SERVER['HTTP_X_FORWARDED_FOR'];

	//check if the forwaded_for ip is valid IPV4 address
	if(ip2long(ipblocker_ipfixer($ipblocker_ban['forwaded_for_ip'])) == -1)
		$ipblocker_ban['forwaded_for_ip'] = '';
	
	if(!empty($ipblocker_ban['forwaded_for_ip'])){
		$ipblocker_ban['forwaded_for_ip_coded'] = sprintf('%u', ip2long(ipblocker_ipfixer($ipblocker_ban['forwaded_for_ip'])));
		//check if the ip forwaded is in a private/reserved range
		//IANA multicast (RFC 3330)
		//if(240.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<255.255.255.255)
		if(3758096384<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<4294967295)
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		//IANA reserved
		//elseif((0.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2.255.255.255) || (5.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<5.255.255.255) || (7.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<7.255.255.255) || (23.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<23.255.255.255) || (27.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<27.255.255.255) || (31.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<31.255.255.255))
		elseif((0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<16777215) || (83886080<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<100663295) || (117440512<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<134217727) || (385875968<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<402653183) || (452984832<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<469762047) || (520093696<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<536870911))
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		//IANA reserved
		//elseif((36.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<37.255.255.255) || (39.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<39.255.255.255) || (41.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<42.255.255.255) || (46.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<46.255.255.255) || (49.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<50.255.255.255) || (73.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<79.255.255.255))
			elseif((603979776<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<637534207) || (654311424<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<671088639) || (687865856<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<721420287) || (771751936<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<788529151) || (822083584<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<855638015) || (1224736768<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<1342177279))
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		//IANA reserved
		//elseif((89.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<126.255.255.255) || (173.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<187.255.255.255) || (189.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<190.255.255.255) || (197.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<197.255.255.255) || (223.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<223.255.255.255))
		elseif((1493172224<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2130706431) || (2902458368<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3154116607) || (3170893824<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3204448255) || (3305111552<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3321888767) || (3741319168<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3758096383))
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		//IANA private use (RFC 1918)
		//elseif((10.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<10.255.255.255) || (127.0.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<127.255.255.255) || (169.254.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<169.254.255.255) || (172.16.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<172.31.255.255) || (192.0.2.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<192.0.2.255) || (192.168.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<192.168.255.255) || (198.18.0.0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<198.19.255.255)
		elseif((167772160<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<184549375) || (2130706432<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2147483647) || (2851995648<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2852061183) || (2886729728<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2887778303) || (3221225984<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3221226239) || (3232235520<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3232301055) || (3323068416<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3323199487))
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		//forwaded_for ip appears to be OK let's get the hostname ;)
		else
			$ipblocker_ban['forwaded_for_hostname'] = gethostbyaddr($ipblocker_ban['forwaded_for_ip']);

		//using proxy or not?
		if($ipblocker_ban['ip_coded'] != $ipblocker_ban['forwaded_for_ip_coded'])
			$ipblocker_ban['using_proxy'] = true;
		else{
			$ipblocker_ban['forwaded_for_ip'] = '';
			$ipblocker_ban['using_proxy'] = false;
		}
	}
}
//end trasparent proxy check

//if total_logging is enabled: log everything :)
if($ipblocker_config['total_logging']){
	if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
		$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." (original ip:".$ipblocker_ban['forwaded_for_ip'].") - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
	else
		$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
	
	//write to the log
	ipblocker_filelogger($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'], $ipblocker_config['string']);

	//file splitting routine
	if(filesize($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename']) > $ipblocker_config['total_logging_filesize'] && $ipblocker_config['total_logging_filesize'] > 0){
		$ipblocker_config['fp'] = @fopen($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'],'r') or die('Error opening/creating the total logger file! cannot proceed');
		@fseek($ipblocker_config['fp'], filesize($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'])-$ipblocker_config['total_logging_filesize']);
		$content = @fread($ipblocker_config['fp'], $ipblocker_config['total_logging_filesize']) or die('Error reading the total logger file! cannot proceed');
		@fclose($ipblocker_config['fp']);
		@unlink($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename']);
		$content = implode('\n',array_slice(explode('\n',$content), 1));
		$ipblocker_config['fp'] = fopen($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'],'w') or die('Error opening/creating the total logger file! cannot proceed');
		@fwrite($ipblocker_config['fp'], $content) or die('Unable to write the total logger file! cannot proceed');
		@fclose($ipblocker_config['fp']) or die('Unable to close the total logger file! cannot proceed');
		unset($content);
	}
	//splitting routine ended
}
//end total_logging

//NOW WE DECIDE IF WE HAVE TO LOG/BLOCK THIS USER

// 1. mysql check
//connect to mysql server
ipblocker_connect();

//control if the ip is in list
if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
	$ipblocker_query_result = @mysql_query('SELECT rangename FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start <= \''.$ipblocker_ban['ip_coded'].'\' AND end >= \''.$ipblocker_ban['ip_coded'].'\' OR start <= \''.$ipblocker_ban['forwaded_for_ip_coded'].'\' AND end >= \''.$ipblocker_ban['forwaded_for_ip_coded'].'\' LIMIT 1', $ipblocker_config['connection_link']) or die('The phpipblocker script wasn\'t able to query the database...<br /><br />Try later and inform the admin...');
else
	$ipblocker_query_result = @mysql_query('SELECT rangename FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start <= \''.$ipblocker_ban['ip_coded'].'\' AND end >= \''.$ipblocker_ban['ip_coded'].'\' LIMIT 1', $ipblocker_config['connection_link']) or die('The phpipblocker script wasn\'t able to query the database...<br /><br />Try later and inform the admin...');
	
//banned or not?
if(@mysql_num_rows($ipblocker_query_result) > 0){
	$ipblocker_query_result = @mysql_fetch_array($ipblocker_query_result);
	$ipblocker_ban['toBlock'] = true;
	$ipblocker_ban['rangename'] = stripslashes($ipblocker_query_result['rangename']);
}
else
	$ipblocker_ban['toBlock'] = false;

//disconnect from mysql server
ipblocker_disconnect();

// 1. mysql blocked
if($ipblocker_ban['toBlock']){
}
// 2. hostname not available?
elseif($ipblocker_config['blockByHostname_ifEmpty'] && ($ipblocker_ban['hostname'] == $ipblocker_ban['ip'])){
	$ipblocker_ban['toBlock'] = true;
	$ipblocker_ban['rangename'] = $ipblocker_ban['hostname'];
}
// 3. unwanted hostname?
elseif(!empty($ipblocker_config['blockByHostname_conditional']) && eregi($ipblocker_config['blockByHostname_conditional'], $ipblocker_ban['hostname'])){
	$ipblocker_ban['toBlock'] = true;
	$ipblocker_ban['rangename'] = $ipblocker_ban['hostname'];
}
else
	$ipblocker_ban['toBlock'] = false;

//MAIN LOGGING/BLOCKING ROUTINE
if($ipblocker_ban['toBlock']){
	//check if the referer is available or not
	if(isset($_SERVER['HTTP_REFERER']))
		$ipblocker_ban['referer'] = trim($_SERVER['HTTP_REFERER']);
	else
		$ipblocker_ban['referer'] = '';
	
	//mail notification
	if($ipblocker_config['sendMail'] && ((!empty($ipblocker_config['notNotifyMail']) && !eregi($ipblocker_config['notNotifyMail'], $ipblocker_ban['rangename'])) || empty($ipblocker_config['notNotifyMail']))){
		$ipblocker_ban['mail_headers'] = 'From: '.$ipblocker_config['adminMail'].' <'.$ipblocker_config['adminMail'].'>\nReply-To: '.$ipblocker_config['adminMail'].'\n\n';
		$ipblocker_ban['mail_text'] = $ipblocker_ban['rangename']." has been tracked while visiting your website\n\nIp that requested the page: ".$ipblocker_ban['ip']."\nHostname: ".$ipblocker_ban['hostname']."\n\nDate: ".date($ipblocker_config['date_format'])."\nRequired Page: ".$_SERVER['REQUEST_URI']."\nClient Port used: ".$_SERVER['REMOTE_PORT']."\nUsed method: ".$_SERVER['REQUEST_METHOD']."\nReferer: ".$ipblocker_ban['referer']."\nSystem: ".$_SERVER['HTTP_USER_AGENT']."\n\n";
		if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_ban['mail_text'] .= "Using Transparent proxy = yes\nOriginal IP (declared by the proxy: not 100% affidable): ".$ipblocker_ban['forwaded_for_ip']."\nOriginal Hostname (declared by the proxy: not 100% affidable): ".$ipblocker_ban['forwaded_for_hostname']."\n";
		elseif(!$ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_ban['mail_text'] .= "Using Transparent proxy = no\n";
		$ipblocker_ban['mail_object'] = "[phpipblocker] ".$ipblocker_ban['rangename']." on your website";
		@mail($ipblocker_config['adminMail'], $ipblocker_ban['mail_object'], $ipblocker_ban['mail_text'], $ipblocker_ban['mail_headers']);
	}
		
	//text logging
	if($ipblocker_config['logAccess'] && ((!empty($ipblocker_config['notLogRanges']) && !eregi($ipblocker_config['notLogRanges'], $ipblocker_ban['rangename'])) || empty($ipblocker_config['notLogRanges']))){
		
		//build the string
		if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." (original ip:".$ipblocker_ban['forwaded_for_ip'].") - ".$ipblocker_ban['rangename']." - ".$_SERVER['REQUEST_URI']." -".$_SERVER['HTTP_USER_AGENT']."\n";
		else
			$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." - ".$ipblocker_ban['rangename']." - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
		
		//write the log
		switch($ipblocker_config['logFrequency']){
			case 'day':
				ipblocker_filelogger($ipblocker_config['fullpathLogName'].''.date('Y').''.date('m').''.date('d').'.log', $ipblocker_config['string']);
				break;
			case 'week':
				ipblocker_filelogger($ipblocker_config['fullpathLogName'].''.date('Y').''.date('W').'.log', $ipblocker_config['string']);
				break;
			case 'month':
				ipblocker_filelogger($ipblocker_config['fullpathLogName'].''.date('Y').''.date('m').'.log', $ipblocker_config['string']);
				break;
			case 'year':
				ipblocker_filelogger($ipblocker_config['fullpathLogName'].''.date('Y').'.log', $ipblocker_config['string']);
				break;
			default:
				ipblocker_filelogger($ipblocker_config['fullpathLogName'].''.$ipblocker_config['logFrequency'], $ipblocker_config['string']);
				break;
		}
	}
		
	//mysql logging (not ready)
	//if($ipblocker_config['db_logging_active'] && ((!empty($ipblocker_config['db_logging_notLogRanges']) && !eregi($ipblocker_config['db_logging_notLogRanges'], $ipblocker_ban['rangename'])) || empty($ipblocker_config['db_logging_notLogRanges'])))
	//	@mysql_query('INSERT INTO '.$ipblocker_config['db_logging_name'].'.'.$ipblocker_config['db_logging_table_name'].' (`date`,`ip`,`ip_forwaded_for`,`requested_page`,`rangename`,`system`)  VALUES (\''.time().'\',\''.$ipblocker_ban['ip_coded'].'\',\''.$ipblocker_ban['forwaded_for_ip'].'\',\''.strtr(mysql_escape_string($_SERVER['REQUEST_URI']), '%', '_').'\',\''.mysql_escape_string($ipblocker_ban['rangename']).'\',\''.strtr(mysql_escape_string(trim($_SERVER['HTTP_USER_AGENT'])), '%', '_').'\')');
		
	//access blocking
	if($ipblocker_config['blockThem']){
		switch($ipblocker_config['blockType']){
			case 0:
				header ('HTTP/1.1 404 Not Found');
				exit();
				break;
			case 1:
				header ('HTTP/1.1 403 Forbidden');
				exit();
				break;
			case 2:
				ipblocker_disconnect();
				header ('Location: '.$ipblocker_config['blockRedirectURL']);
				exit();
				break;
			case 3:
				//for security reason we cleanup all the config options
				$ipblocker_ban['admin_mail'] = $ipblocker_config['adminMail'];
				unset($ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion);
				//build the replacements arrays				
				$ipblocker_ban['template_in'] = array('_adminMail_plain_','_adminMail_encoded_','_rangename_','_ip_','_hostname_','_forwaded_for_ip_','_forwaded_for_hostname_');
				$ipblocker_ban['template_out'] = array($ipblocker_ban['admin_mail'], ipblocker_encode_mail($ipblocker_ban['admin_mail']), $ipblocker_ban['rangename'], $ipblocker_ban['ip'], $ipblocker_ban['hostname'], $ipblocker_ban['forwaded_for_ip'], $ipblocker_ban['forwaded_for_hostname']);
				//load the template
				$ipblocker_ban['stop_text'] = implode('', file(_phpipblocker_dir_.'template.html'));
				//fill the template
				$ipblocker_ban['stop_text'] = str_replace($ipblocker_ban['template_in'], $ipblocker_ban['template_out'], $ipblocker_ban['stop_text']);
				//print the message
				die($ipblocker_ban['stop_text']);
				break;
		}
	}
}
//clean up the memory used ^_'
unset($ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion, $ipblocker_ban, $ipblocker_query_result);

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>